Unit PBench;
{
 "Product of my Spare Time"

 LAST UPDATE: 11.07.98
 AUTHOR: L.Kovri (lkovari@freemail.c3.hu)

 If you Found some bug refer me please...
 Thanks.
}

Interface

Uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, Cpuinfo, CpuInfoF, Spin, About, Math;


Type


  TPBenchFr = Class ( TForm )
    Panel2 : TPanel;
    CloseBtn : TBitBtn;
    Panel3 : TPanel;
    Panel5 : TPanel;
    Panel1 : TPanel;
    HistoryMem : TMemo;
    CpuInfoBtn : TBitBtn;
    IntChb : TCheckBox;
    FloatChb : TCheckBox;
    TrigChb : TCheckBox;
    LogChb : TCheckBox;
    LogicChb : TCheckBox;
    SortChb : TCheckBox;
    PrimeChb : TCheckBox;
    StartBtn : TBitBtn;
    Label1 : TLabel;
    Panel4 : TPanel;
    AboutBtn : TBitBtn;
    SaveBtn : TBitBtn;
    FactChb : TCheckBox;
    ListChb : TCheckBox;
    ArfChb : TCheckBox;
    MipsLbl : TLabel;
    Procedure FormActivate ( Sender : TObject );
    Procedure CpuInfoBtnClick ( Sender : TObject );
    Procedure StartBtnClick ( Sender : TObject );
    Procedure AboutBtnClick ( Sender : TObject );
    Procedure SaveBtnClick ( Sender : TObject );
    Procedure CloseBtnClick ( Sender : TObject );
  private
    { Private declarations }
  public
    { Public declarations }


  End;

Var
  PBenchFr                              : TPBenchFr;
  w, divid                              : integer;
  w1                                    : TStringList;
  et, Bt                                : TDateTime;
  Hour, Min, Sec, Msec                  : word;
  Thousand                              : Currency;
  Exec                                  : boolean;
  PMips                                 : Double;

  CI                                    : TCPUFeatures;
  CpuTst                                : Boolean;

  AverInteger,
    AverFloat,
    AverArithFn,
    AverTrig,
    AverLogarithm,
    AverLog                             : double;

Procedure QuickSort ( Var s : TStringList; l, r : longint );
Procedure genstr ( Var s : tstringlist; n : longint; ls : integer );


Implementation

{$R *.DFM}

Function IsPrime ( act : extended ) : boolean;

Var
  divider, res,
    a                                   : extended;
  two, prim, no                         : boolean;
Begin
  a := act;
  prim := False;
  no := false;
  Result := false;
  { If the Checkable Value less five then the first value of divider equel 2}
  If a <= 5 Then
    divider := 2
  Else
    divider := 5;
  If ( ( ( a / 2 ) = trunc ( a / 2 ) ) Or ( ( a / 3 ) = ( trunc ( a / 3 ) ) ) ) Then Begin
      {If Dividable 2 or 3 then not Prime }
      If ( a = 2 ) Or ( a = 3 ) Then Begin
          {The 2 is Prime!}
					prim := true;
          Result := true;
        End;
    End
  Else Begin
      (* Nem pros igy vizsglhatjuk *)
      two := true;
      If Not prim Then
        Repeat
          res := a / divider;
          (* Megnzzk elosztja-e maradk nlkl *)
          If ( res = trunc ( a / divider ) ) Then Begin
              no := true;
              (* Csak azrt hogyha egy is oszthat felesleges *)
              (* tovbb osztani ki kell lpni a REPEAT -bl! *)
              divider := a;
            End;
          (* Ha kisebb a vizsgland mint 5 akkor 1-gyel nvel *)
          If a <= 5 Then
            divider := divider + 1
          Else Begin
              (* Kvetkez oszt szm *)
              If two Then
                divider := divider + 2
              Else
                divider := divider + 4;
            End;
        Until divider > sqrt ( a );
      (* Ha nem tudta elosztani akkor kirja a primet *)
      If ( Not no ) Then
        Result := true;
    End;
End;


Function GenPrime ( N : extended ) : longint;
Var
  p                                     : longint;
  i                                     : Extended;
Begin
  i := 1;
  p := 0;
  et := Now;
  Repeat
    If IsPrime ( i ) Then
      P := P + 1;
    i := i + 1;
  Until i > N;
  et := now - et;
  decodetime ( et, Hour, Min, Sec, Msec );
  Result := p;
End;


Procedure QuickSort ( Var s : TStringList; l, r : longint );

Var
  l1, r1                                : longint;
  t1, tr                                : String;

Begin
  l1 := l;
  r1 := r;
  t1 := s.Strings [ ( l1 + r1 ) Div 2 ];
  While l1 <= r1 Do Begin
      While s.Strings [ l1 ] < t1 Do
        l1 := l1 + 1;
      While s.Strings [ r1 ] > t1 Do
        r1 := r1 - 1;
      If l1 <= r1 Then Begin
          tr := s.strings [ l1 ];
          s.Strings [ l1 ] := s.strings [ r1 ];
          s.strings [ r1 ] := tr;
          l1 := l1 + 1;
          r1 := r1 - 1;
        End;
    End;
  If l < r1 Then QuickSort ( s, l, r1 );
  If l1 < r Then QuickSort ( s, l1, r );
End;

Procedure genstr ( Var s : tstringlist; n : longint; ls : integer );
Var
  j                                     : longint;
  i                                     : integer;
  k                                     : byte;
  s1                                    : String;
Begin
  randomize;
  j := 0;
  Repeat
    s1 := '';
    i := 1;
    // one line
    Repeat
			k := 0;
      // one char
      Repeat
        k := random ( 3467 );
      Until ( ( k >= 65 ) And ( k <= 90 ) );
      s1 := s1 + chr ( k );
      i := i + 1;
    Until i > ls;
    s.Add ( s1 );
    j := j + 1;
  Until j >= n;
End;

Function GetMips ( C : longint; T : Currency ) : double;
Begin
  Result := ( 1000 / ( T / C ) ) / 1000000;
End;

Procedure TPBenchFr.FormActivate ( Sender : TObject );
Begin
  PBenchFr.Width := 580;
  PBenchFr.Height := 463;
  CpuTst := False;
  CI := TCPUFeatures.create ( Application );
  If CI.CpuIdAvailable Then Begin
      CpuInfoBtn.Caption := Ci.CpuType + ' ' + Ci.CpuModel + ' Info';
      CpuTst := True;
    End
  Else
    CpuInfoBtn.Visible := False;
  IntChb.Checked := False;
  FloatChb.Checked := False;
  TrigChb.Checked := False;
  LogChb.Checked := False;
  LogicChb.Checked := False;
  SortChb.Checked := False;
  PrimeChb.Checked := False;
  SaveBtn.Visible := False;
  MipsLbl.Visible := False;
End;





Procedure TPBenchFr.CpuInfoBtnClick ( Sender : TObject );
Begin
  CpuIDFr.ShowModal;
End;



Function GetEllapsed : String;
Begin
  result := inttostr ( Hour ) + ' Hour ' + inttostr ( min ) + ' Min ' + inttostr ( sec ) +
    ' Sec ' + inttostr ( Msec ) + ' Thousands';
End;

Function GetThousand ( D : TDatetime ) : currency;
Var
  H, M, S, T                            : word;
  Hundreds                              : currency;
Begin
  decodetime ( D, H, M, S, T );
  Hundreds := T;
  Hundreds := Hundreds + ( S * 1000 );
  Hundreds := Hundreds + ( ( M * 60 ) * 1000 );
  Hundreds := Hundreds + ( ( ( H * 60 ) * 60 ) * 1000 );
  Result := Hundreds;
End;

Procedure TestInt ( C : longint );
Var
  // Short integer
  AAddshrt, BAddShrt, CAddShrt,
    ASubshrt, BSubShrt, CSubShrt,
    AMulshrt, BMulShrt, CMulShrt,
    ADivshrt, BDivShrt                  : Shortint;
  CDivShrt                              : real;
  AverShrt                              : double;

  AAddsmli, BAddSmli, CAddSmli,
    ASubsmli, BSubSmli, CSubSmli,
    AMulsmli, BMulSmli, CMulSmli,
    ADivsmli, BDivSmli                  : Smallint;
  CDivSmli                              : real;
  AverSmli                              : double;

  AAddloin, BAddloin, CAddloin,
    ASubloin, BSubloin, CSubloin,
    AMulloin, BMulloin, CMulloin,
    ADivloin, BDivloin                  : longint;
  CDivloin                              : real;
  Averloin                              : double;

  AAddbyte, BAddbyte, CAddbyte,
    ASubbyte, BSubbyte, CSubbyte,
    AMulbyte, BMulbyte, CMulbyte,
    ADivbyte, BDivbyte                  : byte;
  CDivbyte                              : real;
  Averbyte                              : double;

  AAddword, BAddword, CAddword,
    ASubword, BSubword, CSubword,
    AMulword, BMulword, CMulword,
    ADivword, BDivword                  : word;
  CDivword                              : real;
  Averword                              : double;

  AVShort, SVShort, MVShort, DVShort,
    AVSmall, SVSmall, MVSmall, DVSmall,
    AVLong, SVLong, MVLong, DVLong,
    AVByte, SVByte, MVByte, DVByte,
    AVWord, SVWord, MVWord, DVWord      : Double;

  Function AddShortint ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    AAddShrt := 123;
    BAddShrt := 100;
    CAddShrt := 0;
    et := Now;
    Repeat
      CAddShrt := AAddShrt + BAddShrt;
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( '- Additions : ' + formatfloat ( '#######.######',
        GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

  Function SubShortint ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    ASubShrt := 123;
    BSubShrt := 100;
    CSubShrt := 0;
    et := Now;
    Repeat
      CSubShrt := ASubShrt - BSubShrt;
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( '- Substractions : ' + formatfloat (
        '#######.######', GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

  Function MulShortint ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    AMulShrt := 12;
    BMulShrt := 2;
    CMulShrt := 0;
    et := Now;
    Repeat
      CMulShrt := AMulShrt * BMulShrt;
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( '- Multiplications : ' + formatfloat (
        '#######.######', GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

  Function DivShortint ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    ADivShrt := 12;
    BDivShrt := 2;
    CDivShrt := 0;
    et := Now;
    Repeat
      CDivShrt := ADivShrt / BDivShrt;
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( '- Divisions : ' + formatfloat ( '#######.######',
        GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

  Function AddSmalint ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    AAddSmli := 12;
    BAddSmli := 2;
    CAddSmli := 0;
    et := Now;
    Repeat
      CAddSmli := AAddSmli + BAddSmli;
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( '- Additions : ' + formatfloat ( '#######.######',
        GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

  Function SubSmalint ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    ASubSmli := 12345;
    BSubSmli := 1234;
    CSubSmli := 0;
    et := Now;
    Repeat
      CSubSmli := ASubSmli - BSubSmli;
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( '- Substractions : ' + formatfloat (
        '#######.######', GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

  Function MulSmalint ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    AMulSmli := 1245;
    BMulSmli := 12;
    CMulSmli := 0;
    et := Now;
    Repeat
      CMulSmli := AMulSmli * BMulSmli;
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( '- Multiplications : ' + formatfloat (
        '#######.######', GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

  Function DivSmalint ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    ADivSmli := 1245;
    BDivSmli := 12;
    CDivSmli := 0;
    et := Now;
    Repeat
      CDivSmli := ADivSmli / BDivSmli;
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( '- Divisions : ' + formatfloat ( '#######.######',
        GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

  Function AddLongint ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    AAddloin := 123456789;
    BAddLoin := 123456789;
    CAddLoin := 0;
    et := Now;
    Repeat
      CAddLoin := AAddLoin + BAddLoin;
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( '- Additions : ' + formatfloat ( '#######.######',
        GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

  Function SubLongint ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    ASubLoin := 123456789;
    BSubLoin := 12345678;
    CSubLoin := 0;
    et := Now;
    Repeat
      CSubLoin := ASubLoin - BSubLoin;
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( '- Substractions : ' + formatfloat (
        '#######.######', GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

  Function MulLongint ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    AMulLoin := 12345789;
    BMulLoin := 1234567;
    CMulLoin := 0;
    et := Now;
    Repeat
      CMulLoin := AMulLoin * BMulLoin;
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( '- Multiplications : ' + formatfloat (
        '#######.######', GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

  Function DivLongint ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    ADivLoin := 124567890;
    BDivLoin := 123456;
    CDivLoin := 0;
    et := Now;
    Repeat
      CDivLoin := ADivLoin / BDivLoin;
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( '- Divisions : ' + formatfloat ( '#######.######',
        GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

  Function AddByte ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    AAddByte := 123;
    BAddByte := 12;
    CAddByte := 0;
    et := Now;
    Repeat
      CAddByte := AAddByte + BAddByte;
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( '- Additions : ' + formatfloat ( '#######.######',
        GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

  Function SubByte ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    ASubByte := 123;
    BSubByte := 12;
    CSubByte := 0;
    et := Now;
    Repeat
      CSubByte := ASubByte - BSubByte;
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( '- Substractions : ' + formatfloat (
        '#######.######', GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

  Function MulByte ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    AMulByte := 12;
    BMulByte := 12;
    CMulByte := 0;
    et := Now;
    Repeat
      CMulByte := AMulByte * BMulByte;
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( '- Multiplications : ' + formatfloat (
        '#######.######', GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

  Function DivByte ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    ADivByte := 124;
    BDivByte := 12;
    CDivByte := 0;
    et := Now;
    Repeat
      CDivByte := ADivByte / BDivByte;
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( '- Divisions : ' + formatfloat ( '#######.######',
        GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

  Function AddWord ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    AAddWord := 12345;
    BAddWord := 1234;
    CAddWord := 0;
    et := Now;
    Repeat
      CAddWord := AAddWord + BAddWord;
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( '- Additions : ' + formatfloat ( '#######.######',
        GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

  Function SubWord ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    ASubWord := 12345;
    BSubWord := 1234;
    CSubWord := 0;
    et := Now;
    Repeat
      CSubWord := ASubWord - BSubWord;
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( '- Substractions : ' + formatfloat (
        '#######.######', GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

  Function MulWord ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    AMulWord := 123;
    BMulWord := 1234;
    CMulWord := 0;
    et := Now;
    Repeat
      CMulWord := AMulWord * BMulWord;
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( '- Multiplications : ' + formatfloat (
        '#######.######', GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

  Function DivWord ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    ADivWord := 12345;
    BDivWord := 123;
    CDivWord := 0;
    et := Now;
    Repeat
      CDivWord := ADivWord / BDivWord;
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( '- Divisions : ' + formatfloat ( '#######.######',
        GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;


Begin
  Screen.Cursor := crHourGlass;
  PBenchFr.HistoryMem.Lines.Add ( '* INTEGER ARITHMETIC:' );
  PBenchFr.HistoryMem.Lines.Add ( ' Execute 8 bit (Short Inteder) arithmetic operations:'
     );
  AVShort := AddShortInt ( C );
  SVShort := SubShortInt ( C );
  MVShort := MulShortInt ( C );
  DVShort := DivShortInt ( C );
  AverShrt := ( AVShort + SVShort + MVShort + DVShort ) / 4;
  PBenchFr.HistoryMem.Lines.Add ( ' 8 bit (Short Inteder) arithmetic operations Average: '
    + formatfloat ( '######.######', AverShrt ) + ' MIPS.' );
  PBenchFr.HistoryMem.Lines.Add ( ' ' );
  PBenchFr.HistoryMem.Lines.Add ( ' Execute 16 bit (Small Inteder) arithmetic operations:'
     );
  AVSmall := AddSmalInt ( C );
  SVSmall := SubSmalInt ( C );
  MVSmall := MulSmalInt ( C );
  DVSmall := DivSmalInt ( C );
  AverSmli := ( AVSmall + SVSmall + MVSmall + DVSmall ) / 4;
  PBenchFr.HistoryMem.Lines.Add (
    ' 16 bit (Small Inteder) arithmetic operations Average: ' + formatfloat (
    '######.######', AverSmli ) + ' MIPS.' );
  PBenchFr.HistoryMem.Lines.Add ( ' ' );
  PBenchFr.HistoryMem.Lines.Add ( ' Execute 32 bit (Long Inteder) arithmetic operations:'
     );
  AVLong := AddLongint ( C );
  SVLong := SubLongint ( C );
  MVLong := MulLongint ( C );
  DVLong := DivLongint ( C );
  AverLoin := ( AVLong + SVlong + MVlong + DVlong ) / 4;
  PBenchFr.HistoryMem.Lines.Add ( ' 32 bit (Long Inteder) arithmetic operations Average: '
    + formatfloat ( '######.######', AverLoin ) + ' MIPS.' );
  PBenchFr.HistoryMem.Lines.Add ( ' ' );
  PBenchFr.HistoryMem.Lines.Add ( ' Execute Byte arithmetic operations:' );
  AVByte := AddByte ( C );
  SVByte := SubByte ( C );
  MVByte := MulByte ( C );
  DVByte := DivByte ( C );
  AverByte := ( AVByte + SVByte + MVByte + DVByte ) / 4;
  PBenchFr.HistoryMem.Lines.Add ( ' Byte arithmetic operations Average: ' + formatfloat (
    '######.######', Averbyte ) + ' MIPS.' );
  PBenchFr.HistoryMem.Lines.Add ( ' ' );
  PBenchFr.HistoryMem.Lines.Add ( ' Execute Word Inteder arithmetic operations:' );
  AVWord := AddWord ( C );
  SVWord := SubWord ( C );
  MVWord := MulWord ( C );
  DVWord := DivWord ( C );
  AverWord := ( AVWord + SVWord + MVWord + DVWord ) / 4;
  PBenchFr.HistoryMem.Lines.Add ( ' Word arithmetic operations Average: ' + formatfloat (
    '######.######', AverWord ) + ' MIPS.' );
  AverInteger := ( AverShrt + AverSmli + AverLoin + AverByte + AverWord ) / 5;
  PBenchFr.HistoryMem.Lines.Add ( '* INTEGER ARITHMETIC: AVERAGE :' + formatfloat (
    '######.######', AverInteger ) + ' MIPS.' );
  Screen.Cursor := crDefault;
End;

Procedure TestFloat ( C : longint );
Var
  AAddReal, bAddReal, CAddReal,
    ASubReal, bSubReal, CSubReal,
    AMulReal, bMulReal, CMulReal,
    ADivReal, bDivReal, CDivReal        : Real;
  AverReal                              : double;

  AAddSingle, bAddSingle, CAddSingle,
    ASubSingle, bSubSingle, CSubSingle,
    AMulSingle, bMulSingle, CMulSingle,
    ADivSingle, bDivSingle, CDivSingle  : Single;
  AverSingle                            : double;

  AAddDouble, bAddDouble, CAddDouble,
    ASubDouble, bSubDouble, CSubDouble,
    AMulDouble, bMulDouble, CMulDouble,
    ADivDouble, bDivDouble, CDivDouble  : Double;
  AverDouble                            : double;

  AAddExtend, bAddExtend, CAddExtend,
    ASubExtend, bSubExtend, CSubExtend,
    AMulExtend, bMulExtend, CMulExtend,
    ADivExtend, bDivExtend, CDivExtend  : Extended;
  AverExtend                            : double;

  AVSqr, AVSQrt,
    AVReal, SVReal, MVReal, DVReal,
    AVSingle, SVSingle, MVSingle, DVSingle,
    AVDouble, SVDouble, MVDouble, DVDouble,
    AVExtend, SVExtend, MVExtend, DVExtend : double;


  Function AddReal ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    AAddReal := 12345.12345;
    BAddReal := 12345.12345;
    CAddReal := 0;
    et := Now;
    Repeat
      CAddReal := AAddReal + BAddReal;
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( '- Additions : ' + formatfloat ( '#######.######',
        GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

  Function SubReal ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    ASubReal := 12345.12345;
    BSubReal := 1345.12345;
    CSubReal := 0;
    et := Now;
    Repeat
      CSubReal := ASubReal - BSubReal;
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( '- Substractions : ' + formatfloat (
        '#######.######', GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

  Function MulReal ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    AMulReal := 12345.12345;
    BMulReal := 12345.12345;
    CMulReal := 0;
    et := Now;
    Repeat
      CMulReal := AMulReal * BMulReal;
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( '- Multiplications : ' + formatfloat (
        '#######.######', GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

  Function DivReal ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    ADivReal := 12345.12345;
    BDivReal := 145.12345;
    CDivReal := 0;
    et := Now;
    Repeat
      CDivReal := ADivReal / BDivReal;
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( '- Divisions : ' + formatfloat ( '#######.######',
        GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

  Function AddSingle ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    ADivSingle := 12345.12345;
    BDivSingle := 145.12345;
    CDivSingle := 0;
    et := Now;
    Repeat
      CDivSingle := ADivSingle + BDivSingle;
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( '- Additions : ' + formatfloat ( '#######.######',
        GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

  Function SubSingle ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    ASubSingle := 12345.12345;
    BSubSingle := 145.12345;
    CSubSingle := 0;
    et := Now;
    Repeat
      CSubSingle := ASubSingle - BSubSingle;
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( '- Substractions : ' + formatfloat (
        '#######.######', GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

  Function MulSingle ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    AMulSingle := 12345.12345;
    BMulSingle := 145.12345;
    CMulSingle := 0;
    et := Now;
    Repeat
      CMulSingle := AMulSingle * BMulSingle;
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( '- Multiplications : ' + formatfloat (
        '#######.######', GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

  Function DivSingle ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    ADivSingle := 12345.12345;
    BDivSingle := 145.12345;
    CDivSingle := 0;
    et := Now;
    Repeat
      CDivSingle := ADivSingle / BDivSingle;
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( '- Divisions : ' + formatfloat ( '#######.######',
        GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

  Function AddDouble ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    AAddDouble := 1234567890.1234567890;
    BAddDouble := 1234567890.1234567890;
    CAddDouble := 0;
    et := Now;
    Repeat
      CAddDouble := AAddDouble + BAddDouble;
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( '- Additions : ' + formatfloat ( '#######.######',
        GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

  Function SubDouble ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    ASubDouble := 1234567890.1234567890;
    BSubDouble := 123456789.1234567890;
    CAddDouble := 0;
    et := Now;
    Repeat
      CSubDouble := ASubDouble - BSubDouble;
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( '- Substractions : ' + formatfloat (
        '#######.######', GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

  Function MulDouble ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    AMulDouble := 1234567890.1234567890;
    BMulDouble := 123456789.1234567890;
    CMulDouble := 0;
    et := Now;
    Repeat
      CMulDouble := AMulDouble * BMulDouble;
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( '- Multiplications : ' + formatfloat (
        '#######.######', GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

  Function DivDouble ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    ADivDouble := 1234567890.1234567890;
    BDivDouble := 123456789.1234567890;
    CDivDouble := 0;
    et := Now;
    Repeat
      CDivDouble := ADivDouble / BDivDouble;
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( '- Divisions : ' + formatfloat ( '#######.######',
        GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

  Function AddExtend ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    AAddExtend := 1234567890.1234567890;
    BAddExtend := 123456789.1234567890;
    CAddExtend := 0;
    et := Now;
    Repeat
      CAddExtend := AAddExtend + BAddExtend;
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( '- Additions : ' + formatfloat ( '#######.######',
        GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

  Function SubExtend ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    ASubExtend := 1234567890.1234567890;
    BSubExtend := 123456789.1234567890;
    CSubExtend := 0;
    et := Now;
    Repeat
      CSubExtend := ASubExtend - BSubExtend;
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( '- Substractions : ' + formatfloat (
        '#######.######', GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

  Function MulExtend ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    AMulExtend := 1234567890.1234567890;
    BMulExtend := 123456789.1234567890;
    CMulExtend := 0;
    et := Now;
    Repeat
      CMulExtend := AMulExtend * BMulExtend;
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( '- Multiplications : ' + formatfloat (
        '#######.######', GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

  Function DivExtend ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    ADivExtend := 1234567890.1234567890;
    BDivExtend := 123456789.1234567890;
    CDivExtend := 0;
    et := Now;
    Repeat
      CDivExtend := ADivExtend / BDivExtend;
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( '- Divisions : ' + formatfloat ( '#######.######',
        GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;




Begin
  Screen.Cursor := crHourGlass;
  PBenchFr.HistoryMem.Lines.Add ( ' ' );
  PBenchFr.HistoryMem.Lines.Add ( '* FLOATING POINT ARITHMETIC:' );
  PBenchFr.HistoryMem.Lines.Add ( ' Execute 48 bit (Real) arithmetic operations:' );
  AVReal := AddReal ( C );
  SVReal := SubReal ( C );
  MVReal := MulReal ( C );
  DVReal := DivReal ( C );
  AverReal := ( AVReal + SVReal + MVReal + DVReal ) / 4;
  PBenchFr.HistoryMem.Lines.Add ( ' 48 bit (Real) arithmetic operations Average : ' +
    formatfloat ( '######.######', AverReal ) + ' MIPS.' );
  PBenchFr.HistoryMem.Lines.Add ( ' ' );
  PBenchFr.HistoryMem.Lines.Add ( ' Execute 32 bit (Single) arithmetic operations:' );
  AVSingle := AddSingle ( C );
  SVSingle := SubSingle ( C );
  MVSingle := MulSingle ( C );
  DVSingle := DivSingle ( C );
  AverSingle := ( AVSingle + SVSingle + MVSingle + DVSingle ) / 4;
  PBenchFr.HistoryMem.Lines.Add ( ' 32 bit (Single) arithmetic operations Average : ' +
    formatfloat ( '######.######', AverSingle ) + ' MIPS.' );
  PBenchFr.HistoryMem.Lines.Add ( ' ' );
  PBenchFr.HistoryMem.Lines.Add ( ' Execute 64 bit (double) arithmetic operations:' );
  AVDouble := AddDouble ( C );
  SVDouble := SubDouble ( C );
  MVDouble := MulDouble ( C );
  DVDouble := DivDouble ( C );
  AverDouble := ( AVDouble + SVDouble + MVDouble + DVDouble ) / 4;
  PBenchFr.HistoryMem.Lines.Add ( ' 64 bit (Double) arithmetic operations Average : ' +
    formatfloat ( '######.######', AverDouble ) + ' MIPS.' );
  PBenchFr.HistoryMem.Lines.Add ( ' ' );
  PBenchFr.HistoryMem.Lines.Add ( ' Execute 80 bit (extended) arithmetic operations:' );
  AVExtend := AddExtend ( C );
  SVExtend := SubExtend ( C );
  MVExtend := MulExtend ( C );
  DVExtend := DivExtend ( C );
  AverExtend := ( AVExtend + SVExtend + MVExtend + DVExtend ) / 4;
  PBenchFr.HistoryMem.Lines.Add ( ' 80 bit (Extend) arithmetic operations Average : ' +
    formatfloat ( '######.######', AverExtend ) + ' MIPS.' );
  AverFloat := ( AverReal + AverSingle + AverDouble + AverExtend ) / 4;
  PBenchFr.HistoryMem.Lines.Add ( '* FLOATING POINT ARITHMETIC:' + formatfloat (
    '######.######', AverFloat ) + ' MIPS.' );
  Screen.Cursor := crDefault;
End;

Procedure ArithFnTest ( C : longint );
Var
  ASqr, ASqrt                           : Extended;

  AVSqr, AVSqrt                         : extended;

  Function ExecSqr ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    ASqr := 0;
    et := Now;
    Repeat
      ASqr := sqr ( 1234567890 );
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( '- Test Square of 1234567890 = ' + floattostr ( sqr
         ( 1234567890 ) ) + ' : ' + formatfloat ( '#######.######', GetMips ( Count,
        GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

  Function ExecSqrt ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    ASqrt := 0;
    et := Now;
    Repeat
      ASqrt := sqrt ( 1234567890 );
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( '- Test Square root of 1234567890 = ' + floattostr (
        sqr ( 1234567890 ) ) + ' : ' + formatfloat ( '#######.######', GetMips ( Count,
        GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

Begin
  Screen.Cursor := crHourGlass;
  PBenchFr.HistoryMem.Lines.Add ( ' ' );
  PBenchFr.HistoryMem.Lines.Add ( '* SQR & SQRT ARITHMETIC FUNCTIONS:' );
  AVSqr := ExecSqr ( C );
  AVSqrt := ExecSqrt ( C );
  AverArithFn := ( AVSqr + AVSqrt ) / 2;
  PBenchFr.HistoryMem.Lines.Add ( '* SQR & SQRT ARITHMETIC FUNCTIONS AVERAGE : ' +
    formatfloat ( '######.######', AverArithFn ) + ' MIPS.' );
  Screen.Cursor := crDefault;
End;

Procedure TrigTest ( C : longint );

Var
  ASin, ACos, AArcTan, ATan, ATanh, AArctanh : Extended;

  VASin, VACos, VAArcTan, VATan, VATanh, VAArcTanh : Double;


  Function Sinus ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    ASin := 0;
    et := Now;
    Repeat
      ASin := sin ( Pi );
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( ' Sinus : ' + formatfloat ( '#######.######',
        GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

  Function CoSinus ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    ACos := 0;
    et := Now;
    Repeat
      ACos := Cos ( Pi );
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( ' Cosinus : ' + formatfloat ( '#######.######',
        GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

  Function ArcTang ( Count : longint ) : double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    AArcTan := 0;
    et := Now;
    Repeat
      AArcTan := ArcTan ( Pi );
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( ' Arcus Tangent : ' + formatfloat (
        '#######.######', GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;


  Function Tangent ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    ATan := 0;
    et := Now;
    Repeat
      ATan := Tan ( Pi );
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( ' Tangent : ' + formatfloat ( '#######.######',
        GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;


  Function TangentHyp ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    ATanh := 0;
    et := Now;
    Repeat
      ATanh := Tanh ( Pi );
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( ' Tangent Hyperbolic: ' + formatfloat (
        '#######.######', GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

  Function ArcTangentHyp ( Count : longint ) : Double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    AArcTanh := 0;
    et := Now;
    Repeat
      AArcTanh := ArcTanh ( Pi );
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( ' Arcus Tangent Hyperbolic : ' + formatfloat (
        '#######.######', GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;


Begin
  Screen.Cursor := crHourGlass;
  PBenchFr.HistoryMem.Lines.Add ( ' ' );
  PBenchFr.HistoryMem.Lines.Add ( '* TRIGONOMETRIC FUNCTIONS:' );
  VASin := Sinus ( C );
  VACos := CoSinus ( C );
  VAArcTan := ArcTang ( C );
  VATan := Tangent ( C );
  VATanh := Tangenthyp ( C );
  VAArcTanh := ArcTangenthyp ( C );
  AverTrig := ( VASin + VACos + VAArcTan + VATan + VATanh + VAArcTanh ) / 6;
  PBenchFr.HistoryMem.Lines.Add ( '* TRIGONOMETRIC FUNCTIONS AVERAGE :' + formatfloat (
    '######.######', AverTrig ) + ' MIPS.' );
  Screen.Cursor := crDefault;
End;

Procedure TestLogarithm ( C : longint );
Var
  ALn, AExp                             : real;
  VALn, VAExp                           : Double;

  Function NaturalLog ( Count : longint ) : double;
  Var
    Cnt                                 : longint;
    e                                   : real;
  Begin
    Cnt := 0;
    ALn := 0;
    e := exp ( 1.0 );
    et := Now;
    Repeat
      ALn := Ln ( e );
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( ' Natural Logarithm : ' + formatfloat (
        '#######.######', GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

  Function Exponent ( Count : longint ) : double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    AExp := 0;
    et := Now;
    Repeat
      AExp := Exp ( 1.0 );
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( ' Exponent : ' + formatfloat ( '#######.######',
        GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;


Begin
  Screen.Cursor := crHourGlass;
  PBenchFr.HistoryMem.Lines.Add ( ' ' );
  PBenchFr.HistoryMem.Lines.Add ( '* LOGARITHMIC FUNCTIONS:' );
  VALn := NaturalLog ( C );
  VAExp := Exponent ( C );
  AverLogarithm := ( VALn + VAExp ) / 2;
  PBenchFr.HistoryMem.Lines.Add ( '* LOGARITHMIC FUNCTIONS: AVERAGE : ' + formatfloat (
    '######.######', AverLogarithm ) + ' MIPS.' );
  Screen.Cursor := crDefault;
End;


Procedure testLogical ( C : longint );
Var
  AAnd, BAnd, CAnd,
    AOr, Bor, COr,
    Anot, CNot, AXor, BXor, CXor        : byte;

  VAAnd, VAor, VAnot, VAXor             : double;

  Function LogAnd ( Count : longint ) : double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    AAnd := 130;
    BAnd := 12;
    CAnd := 0;
    et := Now;
    Repeat
      CAnd := AAnd And BAnd;
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( ' Logical And Instruction : ' + formatfloat (
        '#######.######', GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

  Function LogOr ( Count : longint ) : double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    AOr := 130;
    BOr := 12;
    COr := 0;
    et := Now;
    Repeat
      COr := AOr Or BOr;
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( ' Logical Or Instruction : ' + formatfloat (
        '#######.######', GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

  Function LogNot ( Count : longint ) : double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    ANot := 130;
    CNot := 0;
    et := Now;
    Repeat
      CNot := Not ANot;
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( ' Logical Not Instruction : ' + formatfloat (
        '#######.######', GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

  Function LogXor ( Count : longint ) : double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    AXor := 130;
    BXor := 12;
    CXor := 0;
    et := Now;
    Repeat
      CXor := BXor Xor ANot;
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    If PBenchFr.ListChb.Checked Then
      PBenchFr.HistoryMem.Lines.Add ( ' Logical Xor Instruction : ' + formatfloat (
        '#######.######', GetMips ( Count, GetThousand ( et ) ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;


Begin
  Screen.Cursor := crHourGlass;
  PBenchFr.HistoryMem.Lines.Add ( ' ' );
  PBenchFr.HistoryMem.Lines.Add ( '* LOGICAL INSTRUCTIONS:' );
  VAAnd := LogAnd ( C );
  VAOr := LogOr ( C );
  VANot := LogNot ( C );
  VAXor := LogXor ( C );
  AverLog := ( VAAnd + VAOr + VANot + VAXor ) / 4;
  PBenchFr.HistoryMem.Lines.Add ( '* LOGICAL INSTRUCTIONS AVERAGE : ' + formatfloat (
    '######.######', AverLog ) + ' MIPS.' );
  Screen.Cursor := crDefault;
End;

Procedure TestFact ( C : longint; Num : integer );
Var
  AFact                                 : currency;
  VAFact                                : double;

  Function fact ( b : currency ) : currency;
  Begin
    If b = 1 Then
      (* Ennek az gnak a beteljeslsig hivja nmagt a fggvny *)
      Result := 1
    Else
      (* Fggvny, mely nmagt hivja - eggyel kisebb rtkkel *)
      fact := fact ( b - 1 ) * b;
    (*       ^ ettl a ponttl folytatdik a fggvny vgrehajtsa ha *)
    (*         nem hivja nmagt ismt *)
  End;

  Function TFact ( Count : longint; N : integer ) : double;
  Var
    Cnt                                 : longint;
  Begin
    Cnt := 0;
    AFact := 0;
    et := Now;
    Repeat
      AFact := Fact ( N );
      Cnt := Cnt + 1;
    Until Cnt > Count;
    et := now - et;
    PBenchFr.HistoryMem.Lines.Add ( ' ' + inttostr ( N ) + ' Factorial is ' + floattostr
       ( AFact ) + ' : ' + formatfloat ( '#######.######', GetMips ( Count, GetThousand (
      et )
			 ) ) + ' MIPS' );
    Result := GetMips ( Count, GetThousand ( et ) );
  End;

Begin
  Screen.Cursor := crHourGlass;
  PBenchFr.HistoryMem.Lines.Add ( ' ' );
  PBenchFr.HistoryMem.Lines.Add ( '* RECURSIVE FACTORIAL CALCULATION:' );
	VAFact := TFact ( C, Num );
  Screen.Cursor := crDefault;
End;

Procedure TPBenchFr.StartBtnClick ( Sender : TObject );
Var
  t1, t2, t3, t4, t5, t6, t7, t8, t9    : boolean;
  primes                                : longint;
Begin
  PMips := 0;
  AverInteger := 0;
  AverFloat := 0;
  AverArithFn := 0;
  AverTrig := 0;
  AverLogarithm := 0;
  AverLog := 0;
  MipsLbl.Visible := False;
  Exec := False;
  HistoryMem.Lines.Clear;
  HistoryMem.Lines.Add ( ' ' );
  Bt := now;
  decodetime ( Bt, Hour, Min, Sec, Msec );
  If CpuTst Then Begin
      HistoryMem.Lines.Add ( '*** BENCHMARK TEST AT ' + GetEllapsed + ' ***' );
      HistoryMem.Lines.Add ( ' ' );
      HistoryMem.Lines.Add ( '> Processor: ' + Ci.CpuType + ' Model: ' + Ci.CpuModel +
        ' Frequency: ' + floattostr ( Ci.CpuSpeed ) + ' Mhz. Vendor: ' + Ci.CpuVendor + '<' );
    End
  Else
    HistoryMem.Lines.Add ( '*** BENCHMARK TEST ' + GetEllapsed + ' ***' );
  HistoryMem.Lines.Add ( ' ' );
  Try
    w1 := TStringlist.Create;
    Try
      t1 := intchb.Checked;
      t2 := floatchb.Checked;
      t3 := Trigchb.Checked;
      t4 := Logchb.Checked;
      t5 := Logicchb.Checked;
      t6 := Sortchb.Checked;
      t7 := Primechb.Checked;
      t8 := Factchb.Checked;
      t9 := ArfChb.Checked;
      If ( ( Not t1 ) And ( Not t2 ) And ( Not t3 ) And ( Not t4 ) And ( Not t5 ) And (
        Not
        t6 ) And ( Not t7 ) And ( Not t8 ) And ( Not t9 ) ) Then
        HistoryMem.Lines.Add ( '>>> SELECTED TESTS MISSING! <<<' )
      Else Begin
          If intChb.Checked Then Begin
              Exec := True;
              TestInt ( 100000000 );
            End;
          If floatChb.Checked Then Begin
              Exec := True;
              TestFloat ( 10000000 );
            End;
          If ArfChb.Checked Then Begin
              Exec := True;
              ArithFnTest ( 10000000 );
            End;
          If trigChb.Checked Then Begin
              Exec := True;
              TrigTest ( 10000000 );
            End;
          If logChb.Checked Then Begin
              Exec := True;
              TestLogarithm ( 20000000 );
            End;
          If logicChb.Checked Then Begin
              Exec := True;
              TestLogical ( 100000000 );
            End;
          If FactChb.Checked Then Begin
              Exec := True;
              TestFact ( 2000000, 17 );
            End;
          If sortChb.Checked Then Begin
              Exec := True;
              Screen.Cursor := crHourGlass;
              HistoryMem.Lines.Add ( ' ' );
							HistoryMem.Lines.Add ( '* QUICK SORT - 70000 string with 70 length ' );
              W1.Clear;
              // Generate strings
              Genstr ( w1, 70000, 70 );
              // Calling the Recursive Quick Sort
              et := Now;
              QuickSort ( w1, 0, w1.Count - 1 );
              et := now - et;
              HistoryMem.Lines.Add ( ' Ellapsed time:' + Formatfloat ( '######.######',
                GetThousand ( et ) ) + ' Thousands' );
              Screen.Cursor := crDefault;
            End;
          If primeChb.Checked Then Begin
              Exec := True;
              Screen.Cursor := crHourGlass;
              Primes := 0;
              HistoryMem.Lines.Add ( ' ' );
              HistoryMem.Lines.Add ( '* GENERATE PRIME NUMBERS TO 700000' );
              Primes := GenPrime ( 700000 );
              HistoryMem.Lines.Add ( ' ' + inttostr ( Primes ) + ' prime generated at ' +
                Formatfloat ( '######.######', GetThousand ( et ) ) + ' Thousands' );
              Screen.Cursor := crDefault;
            End;
          If Exec Then Begin
              SaveBtn.Visible := True;
              Bt := Now - Bt;
              Divid := 0;
              If intChb.Checked Then Begin
                  Divid := 1;
                  PMips := PMips + AverInteger;
                End;
              If floatChb.Checked Then Begin
                  Divid := Divid + 1;
                  PMips := PMips + AverFloat;
                End;
              If ArfChb.Checked Then Begin
                  Divid := Divid + 1;
                  PMips := PMips + AverArithFn;
                End;
              If trigChb.Checked Then Begin
                  Divid := Divid + 1;
                  PMips := PMips + AverTrig;
                End;
              If logChb.Checked Then Begin
                  Divid := Divid + 1;
                  PMips := PMips + AverLogarithm;
                End;
              If logicChb.Checked Then Begin
                  Divid := Divid + 1;
                  PMips := PMips + AverLog;
                End;
              If t1 Or t2 Or t3 Or t4 Or t5 Or t9 Then Begin
                  PMips := Pmips / Divid;
                  HistoryMem.Lines.Add ( ' ' );
                  HistoryMem.Lines.Add ( '*** EXECUTED TESTS AVERAGE :' + formatfloat (
                    '######.######', PMips ) + ' ***' );
                  MipsLbl.Caption := 'INDEX : ' + formatfloat ( '######.######', PMips );
                  MipsLbl.Visible := True;
                End;
              HistoryMem.Lines.Add ( ' ' );
              HistoryMem.Lines.Add ( ' *** TESTS FINISHED AT ' + datetimetostr ( Now ) +
                ' ***' );
              decodetime ( Bt, Hour, Min, Sec, Msec );
              HistoryMem.Lines.Add ( ' ' );
              HistoryMem.Lines.Add ( ' *** ELLAPSED TIME DURING TEST IS ' + GetEllapsed +
                ' ***' );
            End;
        End;
    Finally
      W1.Free;
      W1 := Nil;
    End;
  Except
    On E : Exception Do
      MessageDlg ( 'Error in the Benchmark Test: ' +
        E.Message, mtError, [ mbOK ], 0 );
  End;
End;

Procedure TPBenchFr.AboutBtnClick ( Sender : TObject );
Begin
  AboutDlg.Showmodal;
End;

Procedure TPBenchFr.SaveBtnClick ( Sender : TObject );
Begin
  PBenchFr.HistoryMem.Lines.SaveToFile ( 'BENCH.TXT' );
  SaveBtn.Visible := False;
End;

Procedure TPBenchFr.CloseBtnClick ( Sender : TObject );
Begin
  Ci.Free;
End;


End.

